Const LDAP_DOMAIN_NAME = "LDAP://DC=domain,DC=ru"
Const ADS_SCOPE_SUBTREE = 2

Function CreateDOMDocument()
  Dim domDoc
  Set domDoc = CreateObject("MSXML2.DOMDocument.4.0")

  Dim domProcessingInstruction
  Set domProcessingInstruction = domDoc.createProcessingInstruction("xml", "version=""1.0""")

  domDoc.appendChild domProcessingInstruction

  Set CreateDomDocument = domDoc
End Function

Function CreateDOMDomainRoot(ByVal domDoc)
  Dim domElement
  Set domElement = domDoc.createElement("Domain")
  Set CreateDOMDomainRoot = domDoc.appendChild(domElement)
End Function

Function CreateDOMComputerRoot(ByVal domDoc, ByVal computerName)
  Dim domElement
  Set domElement = domDoc.createElement("Computer")
  domElement.setAttribute "Name", computerName
  Set CreateDOMComputerRoot = domDoc.appendChild(domElement)
End Function

Function CreateDOMItemNode(ByVal domDomain, ByVal computerName)
  Dim domElement
  Set domElement = domDomain.ownerDocument.createElement("Item")
  domElement.text = computerName
  Set CreateDOMItemNode = domDomain.appendChild(domElement)
End Function

Sub CreateDOMComputerElementNode(ByVal domComputer, ByVal oSet, ByVal elementName)
  Dim s
  Dim objItem
  Dim objItemProperty
  Dim domElement

  On Error Resume Next

  For Each objItem In oSet
    Set domElement = domComputer.ownerDocument.createElement(elementName)

    For Each objItemProperty In objItem.Properties_
      if (VarType(objItemProperty.Value) >= 2) and (VarType(objItemProperty.Value) <= 17) then
        domElement.setAttribute objItemProperty.Name, Trim(objItemProperty.Value)
      end if
    Next

    domComputer.appendChild domElement
  Next

  If Err.Number <> 0 Then Err.Clear
End Sub

'Execute query to domain
  Dim objConnection
  Set objConnection = CreateObject("ADODB.Connection")
  objConnection.Provider = "ADsDSOObject"
  objConnection.Open "Active Directory Provider"

  Dim objCommand
  Set objCommand = CreateObject("ADODB.Command")
  Set objCommand.ActiveConnection = objConnection
  objCommand.CommandText = "Select Name from '" & LDAP_DOMAIN_NAME & "' Where objectClass='computer'"
  objCommand.Properties("Page Size") = 1000
  objCommand.Properties("Searchscope") = ADS_SCOPE_SUBTREE

  Dim objMachineSet
  Set objMachineSet = objCommand.Execute

'create XML document
  Dim computerName
  Dim domDoc
  Dim domDomain
  Dim domComputer
  Set domDoc = CreateDOMDocument
  domDoc.appendChild domDoc.createProcessingInstruction("xml-stylesheet", "type=""text/xsl"" href=""invent.xsl""")
  Set domDomain = CreateDOMDomainRoot(domDoc)

  Dim domInDoc
  Dim domInComputer

'Get script path
  frompath = Left(WScript.ScriptFullName, Len(wscript.scriptfullname) - Len(WScript.scriptName))

'WMI
  Dim oWMI

'walk to query result
  On Error Resume Next
  objMachineSet.MoveFirst

'  for i=0 to 3
  Do Until objMachineSet.EOF
    computerName = objMachineSet.Fields("Name").Value
    'WScript.Echo computerName

    Set oWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & computerName & "\root\cimv2")
    If Err.Number = 0 Then
      Set domInDoc = CreateDOMDocument
      domInDoc.appendChild domInDoc.createProcessingInstruction("xml-stylesheet", "type=""text/xsl"" href=""shortinfo.xsl""")

      Set domInComputer = CreateDOMComputerRoot(domInDoc, computerName)

      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_Processor", , 48), "Processor"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_MemoryDevice", , 48), "MemoryDevice"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_PhysicalMemory", , 48), "PhysicalMemory"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_DiskDrive", , 48), "DiskDrive"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_VideoController", , 48), "VideoController"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_NetworkAdapter", , 48), "NetworkAdapter"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_DesktopMonitor", , 48), "DesktopMonitor"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_OperatingSystem", , 48), "OperatingSystem"
      CreateDOMComputerElementNode domInComputer, oWMI.ExecQuery("Select * from Win32_Product", , 48), "Product"

      domInDoc.Save frompath & computerName & ".xml"

      Set domComputer = CreateDOMItemNode(domDomain, computerName)
    Else
      Err.Clear
    End If

    objMachineSet.MoveNext
  Loop
'  next

  objConnection.Close

'save XML document
  domDoc.Save frompath & "invent " & Date & ".xml"