<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:template match="*">
    <html>
    <head>
    <meta content="text/html; charset=windows-1251" http-equiv="Content-Type"/>
    <link href="invent.css" rel="stylesheet" type="text/css"/>
    <script src="invent.js" language="JavaScript" charset="windows-1251"/>
    </head>
    <table class="sort" width="100%" border="1">
      <thead>
      <tr>
      <td>Name</td>
      <td>CPU, MHz</td>
      <td>RAM, Mb</td>
      <td>HDD, Gb</td>
      <td>Video, Mb</td>
      <td>Monitor</td>
      </tr>
      </thead>
      <tbody>
      <xsl:apply-templates select="Item"/>
      </tbody>
      <tr>
      <td>Average:</td>
      </tr>
    </table>
    </html>
  </xsl:template>

  <xsl:template match="Item">
    <xsl:copy>
      <xsl:apply-templates select="document(concat(.,'.xml'))"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="Computer">
    <tr>
    <td><xsl:value-of select="@Name"/></td>
    <td><xsl:value-of select="Processor/@MaxClockSpeed"/></td>
    <td><xsl:value-of select="round(sum(child::PhysicalMemory/@Capacity) div 1024 div 1024)"/></td>
    <td><xsl:value-of select="floor(sum(DiskDrive/@Size) div 1024 div 1024 div 1024)"/></td>
    <td><xsl:value-of select="floor(VideoController/@AdapterRAM div 1024 div 1024)"/></td>
    <td><xsl:value-of select="DesktopMonitor/@Name"/></td>
    </tr>
  </xsl:template>

</xsl:stylesheet>
